﻿//******************************************************************************
//Name          : Random.cs
//Description   : Implementation to experience the beauty and the pitfalls of Random
//                numbers
//Author        : Dr. Oliver Kluge, 90411 Nuernberg, Germany
//Copyright(C)  : Oliver Kluge 2014 
//------------------------------------------------------------------------------
//******************************************************************************

using System;


namespace MyRandom
{
    class Random
    {
        const double PI = 3.14159265358979323846;

        private double ud1;	    // 1st uniform distribution
        private double ud2;	    // 2nd uniform distribution
        private double nd;      // normal distribution
        private double ed;      // exponential distribution

        // c'tor
        public Random(double init1, double init2)
        {
            ud1 = init1;
            ud2 = init2;
            nd  = 0;
            ed  = 0;
        }

        public double Uniform1()
        {
            ud1 = (2001.0*ud1 + 100000.0/3.0) - (int)(2001.0*ud1 + 100000.0/3.0);
            return ud1;
        }

        public double Uniform2()
        {
            ud2 = (1701.0*ud2 + 100000.0/3.0) - (int)(1701.0*ud2 + 100000.0/3.0);
            return ud2;
        }

        public double Normal(double mean, double sigma)
        {
            nd  = sigma * Math.Sqrt(-2.0*Math.Log(Uniform1(), 2.0))*Math.Sin(2.0*PI*Uniform2()) + mean;
            return nd;
        }

        public double Exponential(double lambda)
        {
            ed  = -(1.0/lambda)*Math.Log(Uniform1() + 1E-12, 2.0);
            return ed;
        }
    }
}
